%define _disable_ld_no_undefined 1
%global pypi_name nassl

Name:       python-%{pypi_name}
Version:    3.1.0
Release:    %mkrel 7
Summary:    Experimental OpenSSL wrapper for Python 3.7+ and SSLyze
Group:      Development/Python
License:    AGPL
URL:        https://pypi.org/project/%{pypi_name}
Source0:    https://github.com/nabla-c0d3/nassl/archive/nassl-%{version}.tar.gz
Source1:    openssl-1.0.2e.tar.gz
Source2:    openssl-1.1.1h.tar.gz
Patch0:		nassl-3.1.0-link-against-system-zlib.patch
Patch1:     d741debb320bf54e8575d35603a44d4eb40fa1f9-1.0.2.patch
Patch2:     d741debb320bf54e8575d35603a44d4eb40fa1f9.patch
BuildRequires:  pkgconfig(openssl)
BuildRequires:  zlib-static-devel

%description
Experimental OpenSSL wrapper for Python 3.7+ and SSLyze. Do NOT use for
anything serious. This code has not been properly tested/reviewed and is
absolutely not production ready.

%package -n python3-%{pypi_name}
Summary:        Experimental OpenSSL wrapper for Python 3.7+ and SSLyze
Group:          Development/Python
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3dist(setuptools)
%{?python_provide:%python_provide python3-%{pypi_name}}

%description -n python3-%{pypi_name}
Experimental OpenSSL wrapper for Python 3.7+ and SSLyze. Do NOT use for
anything serious. This code has not been properly tested/reviewed and is
absolutely not production ready.

%prep
%setup -q -n %{pypi_name}-%{version}
%patch0 -p1

# extract openssl sources where build scripts expects to find them
mkdir deps
cd deps
tar xf %{SOURCE1}
tar xf %{SOURCE2}
mv openssl-1.0.2e openssl-OpenSSL_1_0_2e
mv openssl-1.1.1h openssl-OpenSSL_1_1_1h
pushd openssl-OpenSSL_1_0_2e
%patch1 -p1
popd
pushd openssl-OpenSSL_1_1_1h
%patch2 -p1
popd

%build
target=linux-x86_64
%ifarch %ix86
target=linux-elf
%endif
%ifarch aarch64
target=linux-aarch64
%endif
%ifarch %arm
target=linux-armv4
%endif
pushd deps/openssl-OpenSSL_1_0_2e
./Configure $target zlib no-zlib-dynamic no-shared enable-rc5 enable-md2 enable-gost enable-cast enable-idea enable-ripemd enable-mdc2 -fPIC
make depend
make
popd

pushd deps/openssl-OpenSSL_1_1_1h
./Configure $target zlib no-zlib-dynamic no-shared enable-rc5 enable-md2 enable-gost enable-cast enable-idea enable-ripemd enable-mdc2 enable-weak-ssl-ciphers enable-tls1_3 no-async -fPIC
make depend
make
popd

%py3_build

%install
%py3_install

rm -rf %{buildroot}%{python3_sitearch}/tests

%files -n python3-%{pypi_name}
%doc LICENSE.txt README.md
%{python3_sitearch}/%{pypi_name}/
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info/


%changelog
* Wed Jan 20 2021 pterjan <pterjan> 3.1.0-7.mga8
+ Revision: 1672618
- Try to fix build on aarch64

* Mon Jan 18 2021 guillomovitch <guillomovitch> 3.1.0-6.mga8
+ Revision: 1672434
- exclude aarch64
- try to build for aarch64 and arm too

* Sun Jan 17 2021 guillomovitch <guillomovitch> 3.1.0-5.mga8
+ Revision: 1672179
- build against a local copy of openssl for modern flavor too, in order to make all features work

* Sat Jan 16 2021 guillomovitch <guillomovitch> 3.1.0-4.mga8
+ Revision: 1672094
- enable legacy openssl 1.0 support
- drop useless build dependencies

* Sat Jan 16 2021 guillomovitch <guillomovitch> 3.1.0-1.mga8
+ Revision: 1672041
- imported package python-nassl

